//**********************************************************************
//
// 	This is useful as a sample on how to create a new user interface
//		ho-ho-ho
//
//**********************************************************************
#include <stdio.h>
#include "userbase.h"

#define BB "\033[01;37m"
#define BP "\033[0m"

static char currentPRL [MAX_PRL];
static unsigned long currentCRC;
static postnet_download *CW;

static void show_CW (postnet_download *CW = CW)
{
	if (!CW) return;
	printf (BB"Title: %s\n"BP, CW->Title);
	printf (BB"In reply to: %s\n"BP, CW->Parent);
	printf (BB"%i replies\n"BP, CW->replies);
	for (int i = 0; i < CW->replies; i++)
		printf (" [%i] " BB"%s [%s] by [%s] at %s\n"BP, i,
			CW->nTitle(i), CW->nPRL(i), CW->nAuthor(i),
			CW->nDate (i));
}

static void Tree (int depth, postnet_download *D)
{
	int i;
	char space [80];
	for (i = 0; i < depth; i++) space [i] = ' ';
	space [i] = 0;

	for (i = 0; i < D->replies; i++) {
		printf ("%s"BB"[%s] [%s] by %s"BP"\n",
			space, D->nTitle(i), D->nPRL(i), D->nAuthor(i));
		postnet_download P (D->nPRL (i));
		if (P.success != PD_OK)
			printf ("%s  N/A\n", space);
		else if (strcasecmp (P.Parent, D->ThisPRL))
			printf (BB"%s Fake!"BP"\n", space);
		else Tree (depth + 3, &P);
	}
}

static void pn_download ()
{
	postnet_download *sv = CW;
	CW = new postnet_download (currentPRL);

	if (CW->success == PD_OK) {
		delete sv;
		show_CW ();
	} else {
		printf (BB"Ho-ho-ho : %i\n"BP, CW->success);
		CW = sv;
	}
}

static void pn_post (bool newone)
{
	char t [MAX_TITLE], fl [100];
	post *p;

	if (!getuserline (BB"what's the title"BP, t, MAX_TITLE)
	|| !getuserline (BB"File containing text"BP, fl, 100)) return;

	zeroCopy Z (fl);
	if (Z.success == ZC_OK)
		if ((p = Submit ((newone)?NULL:currentPRL, t, Z.d, Z.len)))
			printf ("New post is %x.%x\n", p->Key, p->rkey);
		else printf ("Ho-Ho-Ho Submit failed!\n");
	else printf (BB"ho-ho-ho, can't open this file\n"BP);
}

static void pn_get ()
{
	postnet_get P (currentPRL, true, currentCRC);
	if (P.content) {
		if (P.itsbinary)
			printf (BB"%i bytesof binary data "BP, P.len);
		else {
			char foo [P.len + 1];
			memcpy (foo, P.content, P.len);
			foo [P.len] = 0;
			printf (BB"%i[------\n%s\n---------]  "BP, P.len, foo);
		}
		printf ((P.crcok)?" {CRC Okey} \n":" {BAD CRC} \n");
	} else printf (BB"ho-ho-ho some kinda error\n"BP);
}

static void pn_head ()
{
	postnet_get P (currentPRL, false);
	if (P.type) {
		printf (BB"Len=%i type=[%s] replies=%i Created [%s]\n"BP
			,P.len,P.type,P.rep,P.date);
	} else printf (BB"Ho-ho-ho\n"BP);
}

static void pn_setcur (char *p)
{
	if (goodPRL (p)) {
		strcpy (currentPRL, p);
		currentCRC = 0;
	} else printf (BB"Not good\n"BP);
}

static void pn_setcurM (char *n)
{
	unsigned int ID = strtoul (n, NULL, 10);
	post *p;

	if ((p = (post*) Globals.Posts.intFind (ID))) {
		sprintf (currentPRL, "%s/%x.%x", Globals.ThisPoint, ID, p->rkey);
		currentCRC = 0;
		
	} else printf (BB"Ho-ho-ho no such post\n"BP);
}

static void pn_setcurR (char *n)
{
	unsigned int ID = strtoul (n, NULL, 10);
	if (CW && CW->nPRL (ID)) {
		strcpy (currentPRL, CW->nPRL (ID));
		currentCRC = ahtoi (CW->nCRC (ID));
	} else printf ("Ho-ho-ho, no such reply\n");
}

static void pn_setcurP ()
{
	if (CW) {
		strcpy (currentPRL, CW->Parent);
		currentCRC = 0;
		pn_download ();
	}
}

static void Delete_Msg ()
{
	if (CW && !strcasecmp (CW->ThisPRL, currentPRL)) {
		if (selfref (CW->Parent)) {
		Admin_Remove_Post (ahtoi (MsgIDofPRL (CW->Parent)), currentPRL);
		} else printf ("We don't have parent post:(\n");
	} else printf ("do 'd' first\n");
}

static void *raw_interface (void*)
{
	char cmd [200];
	sprintf (currentPRL, "%s/0.0", Globals.ThisPoint);

fprintf (stderr, "Go [raw_interface]\n");

	while (getuserline (BB"[user @ host] #"BP, cmd, 200))
	switch (cmd [0]) {
	case '/':
		pn_setcur (cmd);
		break;
	case 'd':
		pn_download ();
		break;
	case 'g':
		pn_get ();
		break;
	case 'p':
		pn_post (cmd [1] == 'n');
		break;
	case 'h':
		pn_head ();
		break;
	case 'S':
		CloseRecovery ();
		break;
#ifdef DEBUG
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
		DebugMessages = DebugMessages ^ (1<<(cmd[0]-'1'));
		break;
#endif
	case '*':
		ShutDown ();
		return NULL;
	case 'T':
		if (CW) Tree (1, CW);
		break;
	case 'D':
		Delete_Msg ();
		break;
	case 'R':
		pn_setcurR (cmd + 1);
		goto sh;
	case 'P':
		pn_setcurP ();
		goto sh;
	case 'M':
		pn_setcurM (cmd + 1);
	case 0:
	sh:
		printf ("Current Post is "BB"%s"BP"\n", currentPRL);
		break;
	case 's':
		show_CW ();
		break;
	default:
		printf ("["BB"/"BP"]\n");
		printf ("["BB"d"BP"ownload replies]\n");
		printf ("["BB"s"BP"how downloaded replies]\n");
		printf ("["BB"g"BP"et content]\n");
		printf ("["BB"p{n}"BP" post new post]\n");
		printf ("["BB"h"BP"ead content]\n");
		printf ("["BB"S"BP"ave database]\n");
		printf ("["BB"M<num>"BP" current post = my <num>th post]\n");
		printf ("["BB"R<num>"BP" current post = <num>th reply]\n");
		printf ("["BB"P"BP" current post = parent]\n");
		printf ("["BB"D"BP"elete current post]\n");
		printf ("["BB"T"BP"ree !!]\n");
		printf ("["BB"*"BP" shut down]\n");
#ifdef DEBUG
		printf ("["BB"{1,2,3,4,5}"BP" toggle debugging messages]\n");
#endif
		break;
	}

	ShutDown ();
	return NULL;
}

void forkraw ()
{
	pthread_t t;

	pthread_create (&t, NULL, raw_interface, NULL);
	pthread_detach (t);
}

/* HCC RESOLVE:
pthread_create()
	raw_interface (Pv)
END */
